searchData={"items":[{"type":"module","title":"GRPC","doc":"","ref":"GRPC.html"},{"type":"function","title":"GRPC.version/0","doc":"Returns version of this project.","ref":"GRPC.html#version/0"},{"type":"module","title":"GRPC.Channel","doc":"A struct to store the connection data, which should be passed to\nRPC functions as the first argument:\n\n    Greeter.Stub.say_hello(channel, request)","ref":"GRPC.Channel.html"},{"type":"module","title":"Fields - GRPC.Channel","doc":"* `:host` - server's host to connect\n  * `:port` - server's port to connect\n  * `:scheme` - scheme of connection, like `http`\n  * `:cred` - credentials used for authentication\n  * `:adapter` - a client adapter module, like `GRPC.Client.Adapters.Gun`\n  * `:codec` - a default codec for this channel\n  * `:adapter_payload` - payload the adapter uses","ref":"GRPC.Channel.html#module-fields"},{"type":"type","title":"GRPC.Channel.t/0","doc":"","ref":"GRPC.Channel.html#t:t/0"},{"type":"behaviour","title":"GRPC.Client.Adapter","doc":"HTTP client adapter for GRPC.","ref":"GRPC.Client.Adapter.html"},{"type":"callback","title":"GRPC.Client.Adapter.cancel/1","doc":"Cancel a stream in a streaming client.","ref":"GRPC.Client.Adapter.html#c:cancel/1"},{"type":"callback","title":"GRPC.Client.Adapter.connect/2","doc":"","ref":"GRPC.Client.Adapter.html#c:connect/2"},{"type":"callback","title":"GRPC.Client.Adapter.disconnect/1","doc":"","ref":"GRPC.Client.Adapter.html#c:disconnect/1"},{"type":"callback","title":"GRPC.Client.Adapter.end_stream/1","doc":"Similarly to the option sent on `send_data/2` - :send_end_stream -\nthis callback will end request stream","ref":"GRPC.Client.Adapter.html#c:end_stream/1"},{"type":"callback","title":"GRPC.Client.Adapter.receive_data/2","doc":"Check `GRPC.Stub.recv/2` for more context about the return types","ref":"GRPC.Client.Adapter.html#c:receive_data/2"},{"type":"callback","title":"GRPC.Client.Adapter.send_data/3","doc":"This callback will be responsible to send data to the server on a stream\nrequest is open using `send_headers/2`\n Opts:\n    - :send_end_stream (optional) - ends the request stream","ref":"GRPC.Client.Adapter.html#c:send_data/3"},{"type":"callback","title":"GRPC.Client.Adapter.send_headers/2","doc":"This callback is used to open a stream connection to the server.\nMostly used when the payload for this request is streamed.\nTo send data using the open stream request, you should use `send_data/3`","ref":"GRPC.Client.Adapter.html#c:send_headers/2"},{"type":"callback","title":"GRPC.Client.Adapter.send_request/3","doc":"","ref":"GRPC.Client.Adapter.html#c:send_request/3"},{"type":"type","title":"GRPC.Client.Adapter.fin/0","doc":"Determines if the headers have finished being read.","ref":"GRPC.Client.Adapter.html#t:fin/0"},{"type":"module","title":"GRPC.Client.Adapters.Gun","doc":"A client adapter using Gun\n\n`conn_pid` and `stream_ref` are stored in `GRPC.Server.Stream`.","ref":"GRPC.Client.Adapters.Gun.html"},{"type":"function","title":"GRPC.Client.Adapters.Gun.retry_fun/2","doc":"","ref":"GRPC.Client.Adapters.Gun.html#retry_fun/2"},{"type":"module","title":"GRPC.Client.Adapters.Mint","doc":"A client adapter using mint","ref":"GRPC.Client.Adapters.Mint.html"},{"type":"function","title":"GRPC.Client.Adapters.Mint.check_for_error/1","doc":"","ref":"GRPC.Client.Adapters.Mint.html#check_for_error/1"},{"type":"function","title":"GRPC.Client.Adapters.Mint.handle_errors_receive_data/2","doc":"","ref":"GRPC.Client.Adapters.Mint.html#handle_errors_receive_data/2"},{"type":"behaviour","title":"GRPC.Client.Interceptor","doc":"Interceptor on client side. See `GRPC.Stub.connect/2`.","ref":"GRPC.Client.Interceptor.html"},{"type":"callback","title":"GRPC.Client.Interceptor.call/4","doc":"","ref":"GRPC.Client.Interceptor.html#c:call/4"},{"type":"callback","title":"GRPC.Client.Interceptor.init/1","doc":"","ref":"GRPC.Client.Interceptor.html#c:init/1"},{"type":"type","title":"GRPC.Client.Interceptor.next/0","doc":"","ref":"GRPC.Client.Interceptor.html#t:next/0"},{"type":"type","title":"GRPC.Client.Interceptor.options/0","doc":"","ref":"GRPC.Client.Interceptor.html#t:options/0"},{"type":"type","title":"GRPC.Client.Interceptor.req/0","doc":"","ref":"GRPC.Client.Interceptor.html#t:req/0"},{"type":"module","title":"GRPC.Client.Interceptors.Logger","doc":"Print log around client rpc calls, like\n\n    17:13:33.021 [info]  Call say_hello of helloworld.Greeter\n    17:13:33.079 [info]  Got :ok in 58ms","ref":"GRPC.Client.Interceptors.Logger.html"},{"type":"module","title":"Options - GRPC.Client.Interceptors.Logger","doc":"* `:level` - the desired log level. Defaults to `:info`","ref":"GRPC.Client.Interceptors.Logger.html#module-options"},{"type":"module","title":"Usage - GRPC.Client.Interceptors.Logger","doc":"{:ok, channel} = GRPC.Stub.connect(\"localhost:50051\", interceptors: [GRPC.Client.Interceptors.Logger])","ref":"GRPC.Client.Interceptors.Logger.html#module-usage"},{"type":"module","title":"Usage with custom level - GRPC.Client.Interceptors.Logger","doc":"{:ok, channel} = GRPC.Stub.connect(\"localhost:50051\", interceptors: [{GRPC.Client.Interceptors.Logger, level: :warning}])","ref":"GRPC.Client.Interceptors.Logger.html#module-usage-with-custom-level"},{"type":"module","title":"GRPC.Client.Stream","doc":"A struct that *streaming* clients get from rpc function calls and use to send further requests.","ref":"GRPC.Client.Stream.html"},{"type":"module","title":"Fields - GRPC.Client.Stream","doc":"* `:channel`           - `GRPC.Channel`, the channel established by client\n  * `:payload`           - data used by adapter in a request\n  * `:path`              - the request path to sent\n  * `:request_mod`       - the request module, or nil for untyped protocols\n  * `:response_mod`      - the response module, or nil for untyped protocols\n  * `:codec`             - the codec\n  * `:req_stream`        - indicates if request is streaming\n  * `:res_stream`        - indicates if reply is streaming","ref":"GRPC.Client.Stream.html#module-fields"},{"type":"function","title":"GRPC.Client.Stream.put_headers/2","doc":"","ref":"GRPC.Client.Stream.html#put_headers/2"},{"type":"function","title":"GRPC.Client.Stream.receive_data/2","doc":"","ref":"GRPC.Client.Stream.html#receive_data/2"},{"type":"type","title":"GRPC.Client.Stream.t/0","doc":"","ref":"GRPC.Client.Stream.html#t:t/0"},{"type":"behaviour","title":"GRPC.Codec","doc":"Contains code to serialize a deserialize the message.","ref":"GRPC.Codec.html"},{"type":"callback","title":"GRPC.Codec.decode/2","doc":"","ref":"GRPC.Codec.html#c:decode/2"},{"type":"callback","title":"GRPC.Codec.encode/1","doc":"","ref":"GRPC.Codec.html#c:encode/1"},{"type":"callback","title":"GRPC.Codec.name/0","doc":"Name is identity of the codec, which will be suffix after content-type \"application/grpc+\" such as \"proto\".","ref":"GRPC.Codec.html#c:name/0"},{"type":"callback","title":"GRPC.Codec.pack_for_channel/1","doc":"This function is invoked whenever it is defined after the protobuf message has been transformed into a gRPC payload.\n\nThis can be used to apply a transform over the gRPC message before sending it.\nFor instance grpc-web using the `application/grpc-web-text` content type requires the message to be Base64-encoded, so a server sending messages using grpc-web-text will be required to\ndo a Base64 encode on the payload before sending the gRPC message.","ref":"GRPC.Codec.html#c:pack_for_channel/1"},{"type":"callback","title":"GRPC.Codec.unpack_from_channel/1","doc":"This function is invoked before the gRPC payload is transformed into a protobuf message whenever it is defined.\n\nThis can be used to apply a transform over the gRPC message before decoding it. For instance grpc-web using the `application/grpc-web-text`\ncontent type requires the message to be Base64-encoded, so a server receving messages using grpc-web-text will be required to\ndo a Base64 decode on the payload before decoding the gRPC message.","ref":"GRPC.Codec.html#c:unpack_from_channel/1"},{"type":"module","title":"GRPC.Codec.Erlpack","doc":"","ref":"GRPC.Codec.Erlpack.html"},{"type":"function","title":"GRPC.Codec.Erlpack.decode/2","doc":"","ref":"GRPC.Codec.Erlpack.html#decode/2"},{"type":"function","title":"GRPC.Codec.Erlpack.encode/1","doc":"","ref":"GRPC.Codec.Erlpack.html#encode/1"},{"type":"function","title":"GRPC.Codec.Erlpack.name/0","doc":"","ref":"GRPC.Codec.Erlpack.html#name/0"},{"type":"module","title":"GRPC.Codec.JSON","doc":"JSON Codec for gRPC communication.\n\nThis module implements the `GRPC.Codec` behaviour, providing encoding and decoding functions\nfor JSON serialization in the context of gRPC communication.","ref":"GRPC.Codec.JSON.html"},{"type":"module","title":"Behavior Functions - GRPC.Codec.JSON","doc":"- `name/0`: Returns the name of the codec, which is \"json\".\n- `encode/1`: Encodes a struct using the Protobuf.JSON.encode!/1 function.\n- `decode/2`: Decodes binary data into a map using the Jason library.\n\nThis module requires the Jason dependency.","ref":"GRPC.Codec.JSON.html#module-behavior-functions"},{"type":"function","title":"GRPC.Codec.JSON.decode/2","doc":"Decodes binary data into a map using the Jason library.\nParameters:\n\n    binary - The binary data to be decoded.\n    module - Module to be created.\n\nReturns:\n\nA map representing the decoded data.\n\nRaises:\n\nRaises an error if the Jason library is not loaded.\n\nExample:\n\n```elixir\nbinary_data |> GRPC.Codec.JSON.decode(__MODULE__)\n```","ref":"GRPC.Codec.JSON.html#decode/2"},{"type":"function","title":"GRPC.Codec.JSON.encode/1","doc":"Encodes a struct using the Protobuf.JSON.encode!/1 function.\n\n#","ref":"GRPC.Codec.JSON.html#encode/1"},{"type":"function","title":"Parameters: - GRPC.Codec.JSON.encode/1","doc":"- `struct` - The struct to be encoded.\n\n#","ref":"GRPC.Codec.JSON.html#encode/1-parameters"},{"type":"function","title":"Returns: - GRPC.Codec.JSON.encode/1","doc":"The encoded binary data.\n\n#","ref":"GRPC.Codec.JSON.html#encode/1-returns"},{"type":"function","title":"Example: - GRPC.Codec.JSON.encode/1","doc":"```elixir\n%MyStruct{id: 1, name: \"John\"} |> GRPC.Codec.JSON.encode()\n```","ref":"GRPC.Codec.JSON.html#encode/1-example"},{"type":"function","title":"GRPC.Codec.JSON.name/0","doc":"","ref":"GRPC.Codec.JSON.html#name/0"},{"type":"module","title":"GRPC.Codec.Proto","doc":"","ref":"GRPC.Codec.Proto.html"},{"type":"function","title":"GRPC.Codec.Proto.decode/2","doc":"","ref":"GRPC.Codec.Proto.html#decode/2"},{"type":"function","title":"GRPC.Codec.Proto.encode/1","doc":"","ref":"GRPC.Codec.Proto.html#encode/1"},{"type":"function","title":"GRPC.Codec.Proto.name/0","doc":"","ref":"GRPC.Codec.Proto.html#name/0"},{"type":"module","title":"GRPC.Codec.WebText","doc":"","ref":"GRPC.Codec.WebText.html"},{"type":"function","title":"GRPC.Codec.WebText.decode/2","doc":"","ref":"GRPC.Codec.WebText.html#decode/2"},{"type":"function","title":"GRPC.Codec.WebText.encode/1","doc":"","ref":"GRPC.Codec.WebText.html#encode/1"},{"type":"function","title":"GRPC.Codec.WebText.name/0","doc":"","ref":"GRPC.Codec.WebText.html#name/0"},{"type":"function","title":"GRPC.Codec.WebText.pack_for_channel/1","doc":"","ref":"GRPC.Codec.WebText.html#pack_for_channel/1"},{"type":"function","title":"GRPC.Codec.WebText.unpack_from_channel/1","doc":"","ref":"GRPC.Codec.WebText.html#unpack_from_channel/1"},{"type":"behaviour","title":"GRPC.Compressor","doc":"","ref":"GRPC.Compressor.html"},{"type":"callback","title":"GRPC.Compressor.compress/1","doc":"","ref":"GRPC.Compressor.html#c:compress/1"},{"type":"callback","title":"GRPC.Compressor.decompress/1","doc":"","ref":"GRPC.Compressor.html#c:decompress/1"},{"type":"callback","title":"GRPC.Compressor.name/0","doc":"","ref":"GRPC.Compressor.html#c:name/0"},{"type":"module","title":"GRPC.Compressor.Gzip","doc":"","ref":"GRPC.Compressor.Gzip.html"},{"type":"function","title":"GRPC.Compressor.Gzip.compress/1","doc":"","ref":"GRPC.Compressor.Gzip.html#compress/1"},{"type":"function","title":"GRPC.Compressor.Gzip.decompress/1","doc":"","ref":"GRPC.Compressor.Gzip.html#decompress/1"},{"type":"function","title":"GRPC.Compressor.Gzip.name/0","doc":"","ref":"GRPC.Compressor.Gzip.html#name/0"},{"type":"module","title":"GRPC.Credential","doc":"Stores credentials for authentication.\n\nIt can be used to establish secure connections\nby passed to `GRPC.Stub.connect/2` as an argument.\n\nSome client and server adapter implementations may\nchoose to let request options override some of the\nconfiguration here, but this is left as a choice\nfor each adapter.","ref":"GRPC.Credential.html"},{"type":"module","title":"Examples - GRPC.Credential","doc":"iex> cred = GRPC.Credential.new(ssl: [cacertfile: ca_path])\n    iex> GRPC.Stub.connect(\"localhost:10000\", cred: cred)","ref":"GRPC.Credential.html#module-examples"},{"type":"function","title":"GRPC.Credential.new/1","doc":"Creates credential.","ref":"GRPC.Credential.html#new/1"},{"type":"type","title":"GRPC.Credential.t/0","doc":"","ref":"GRPC.Credential.html#t:t/0"},{"type":"module","title":"GRPC.Endpoint","doc":"GRPC endpoint for multiple servers and interceptors.","ref":"GRPC.Endpoint.html"},{"type":"module","title":"Usage - GRPC.Endpoint","doc":"defmodule Your.Endpoint do\n      use GRPC.Endpoint\n\n      intercept GRPC.Server.Interceptors.Logger, level: :info\n      intercept Other.Interceptor\n      run HelloServer, interceptors: [HelloHaltInterceptor]\n      run FeatureServer\n    end\n\nInterceptors will be run around your rpc calls from top to bottom. And you can even set\ninterceptors for some of servers. In the above example, `[GRPC.Server.Interceptors.Logger, Other.Interceptor,\nHelloHaltInterceptor]` will be run for `HelloServer`, and `[GRPC.Server.Interceptors.Logger, Other.Interceptor]`\nwill be run for `FeatureServer`.","ref":"GRPC.Endpoint.html#module-usage"},{"type":"macro","title":"GRPC.Endpoint.intercept/1","doc":"","ref":"GRPC.Endpoint.html#intercept/1"},{"type":"macro","title":"GRPC.Endpoint.intercept/2","doc":"","ref":"GRPC.Endpoint.html#intercept/2"},{"type":"macro","title":"Options - GRPC.Endpoint.intercept/2","doc":"`opts` keyword will be passed to Interceptor's init/1","ref":"GRPC.Endpoint.html#intercept/2-options"},{"type":"macro","title":"GRPC.Endpoint.run/2","doc":"","ref":"GRPC.Endpoint.html#run/2"},{"type":"macro","title":"Options - GRPC.Endpoint.run/2","doc":"* `:interceptors` - custom interceptors for these servers","ref":"GRPC.Endpoint.html#run/2-options"},{"type":"module","title":"GRPC.Message","doc":"Transform data between encoded protobuf and HTTP/2 body of gRPC.\n\ngRPC body format is:\n\n  http://www.grpc.io/docs/guides/wire.html\n  Delimited-Message -> Compressed-Flag Message-Length Message\n  Compressed-Flag -> 0 / 1 # encoded as 1 byte unsigned integer\n  Message-Length -> {length of Message} # encoded as 4 byte unsigned integer\n  Message -> *{binary octet}","ref":"GRPC.Message.html"},{"type":"function","title":"GRPC.Message.complete?/1","doc":"","ref":"GRPC.Message.html#complete?/1"},{"type":"function","title":"GRPC.Message.from_data/1","doc":"Transforms gRPC body into Protobuf data.","ref":"GRPC.Message.html#from_data/1"},{"type":"function","title":"Examples - GRPC.Message.from_data/1","doc":"iex> GRPC.Message.from_data(<<0, 0, 0, 0, 8, 1, 2, 3, 4, 5, 6, 7, 8>>)\n    <<1, 2, 3, 4, 5, 6, 7, 8>>","ref":"GRPC.Message.html#from_data/1-examples"},{"type":"function","title":"GRPC.Message.from_data/2","doc":"Transform gRPC body into Protobuf data with compression.","ref":"GRPC.Message.html#from_data/2"},{"type":"function","title":"Examples - GRPC.Message.from_data/2","doc":"iex> GRPC.Message.from_data(%{compressor: nil}, <<0, 0, 0, 0, 8, 1, 2, 3, 4, 5, 6, 7, 8>>)\n    {:ok, <<1, 2, 3, 4, 5, 6, 7, 8>>}","ref":"GRPC.Message.html#from_data/2-examples"},{"type":"function","title":"GRPC.Message.from_frame/1","doc":"","ref":"GRPC.Message.html#from_frame/1"},{"type":"function","title":"GRPC.Message.from_frame/2","doc":"","ref":"GRPC.Message.html#from_frame/2"},{"type":"function","title":"GRPC.Message.get_message/1","doc":"Get message data from data buffer.","ref":"GRPC.Message.html#get_message/1"},{"type":"function","title":"Examples - GRPC.Message.get_message/1","doc":"iex> GRPC.Message.get_message(<<0, 0, 0, 0, 8, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0, 0>>)\n    {{0, <<1, 2, 3, 4, 5, 6, 7, 8>>}, <<0, 0, 0>>}\n    iex> GRPC.Message.get_message(<<1, 0, 0, 0, 8, 1, 2, 3, 4, 5, 6, 7, 8>>)\n    {{1, <<1, 2, 3, 4, 5, 6, 7, 8>>}, <<>>}\n    iex> GRPC.Message.get_message(<<0, 0, 0, 0, 8, 1, 2, 3, 4, 5, 6, 7>>)\n    false","ref":"GRPC.Message.html#get_message/1-examples"},{"type":"function","title":"GRPC.Message.get_message/2","doc":"","ref":"GRPC.Message.html#get_message/2"},{"type":"function","title":"GRPC.Message.message_length/1","doc":"","ref":"GRPC.Message.html#message_length/1"},{"type":"function","title":"GRPC.Message.to_data/2","doc":"Transforms Protobuf data into a gRPC body binary.","ref":"GRPC.Message.html#to_data/2"},{"type":"function","title":"Options - GRPC.Message.to_data/2","doc":"* `:compressor` - the optional `GRPC.Compressor` to be used.\n  * `:iolist` - if `true`, encodes the data as an `t:iolist()` instead of a `t:binary()`\n  * `:max_message_length` - the maximum number of bytes for the encoded message.","ref":"GRPC.Message.html#to_data/2-options"},{"type":"function","title":"Examples - GRPC.Message.to_data/2","doc":"iex> message = [\"m\", [[\"es\", \"sa\"], \"ge\"]]\n    iex> GRPC.Message.to_data(message)\n    {:ok, <<0, 0, 0, 0, 7, \"message\">>, 12}\n    iex> GRPC.Message.to_data(message, iolist: true)\n    {:ok, [0, <<0, 0, 0, 7>>, [\"m\", [[\"es\", \"sa\"], \"ge\"]]], 12}\n\nError cases:\n\n    iex> message = <<1, 2, 3, 4, 5, 6, 7, 8, 9>>\n    iex> GRPC.Message.to_data(message, %{max_message_length: 8})\n    {:error, \"Encoded message is too large (9 bytes)\"}","ref":"GRPC.Message.html#to_data/2-examples"},{"type":"module","title":"GRPC.Protoc.CLI","doc":"`protoc` plugin for generating Elixir code.\n\n`protoc-gen-elixir` (this name is important) **must** be in `$PATH`. You are not supposed\nto call it directly, but only through `protoc`.","ref":"GRPC.Protoc.CLI.html"},{"type":"module","title":"Examples - GRPC.Protoc.CLI","doc":"$ protoc --elixir_out=./lib your.proto\n    $ protoc --elixir_out=plugins=grpc:./lib/ *.proto\n    $ protoc -I protos --elixir_out=./lib protos/namespace/*.proto\n\nOptions:\n\n  * --version       Print version of protobuf-elixir\n  * --help (-h)     Print this help","ref":"GRPC.Protoc.CLI.html#module-examples"},{"type":"function","title":"GRPC.Protoc.CLI.supported_features/0","doc":"","ref":"GRPC.Protoc.CLI.html#supported_features/0"},{"type":"module","title":"GRPC.Server","doc":"A gRPC server which handles requests by calling user-defined functions.\n\nYou should pass a `GRPC.Service` in when *use* the module:\n\n    defmodule Greeter.Service do\n      use GRPC.Service, name: \"ping\"\n\n      rpc :SayHello, Request, Reply\n      rpc :SayGoodbye, stream(Request), stream(Reply)\n    end\n\n    defmodule Greeter.Server do\n      use GRPC.Server, service: Greeter.Service\n\n      def say_hello(request, _stream) do\n        Reply.new(message: \"Hello\")\n      end\n\n      def say_goodbye(request_enum, stream) do\n        requests = Enum.map request_enum, &(&1)\n        GRPC.Server.send_reply(stream, reply1)\n        GRPC.Server.send_reply(stream, reply2)\n      end\n    end\n\nYour functions should accept a client request and a `GRPC.Server.Stream`.\nThe request will be a `Enumerable.t`(created by Elixir's `Stream`) of requests\nif it's streaming. If a reply is streaming, you need to call `send_reply/2` to send\nreplies one by one instead of returning reply in the end.","ref":"GRPC.Server.html"},{"type":"module","title":"gRPC HTTP/JSON transcoding - GRPC.Server","doc":"Transcoding can be enabled by using the option `http_transcode: true`:\n\n    defmodule Greeter.Service do\n      use GRPC.Service, name: \"ping\"\n\n      rpc :SayHello, Request, Reply\n      rpc :SayGoodbye, stream(Request), stream(Reply)\n    end\n\n    defmodule Greeter.Server do\n      use GRPC.Server, service: Greeter.Service, http_transcode: true\n\n      def say_hello(request, _stream) do\n        Reply.new(message: \"Hello\" <> request.name)\n      end\n\n      def say_goodbye(request_enum, stream) do\n        requests = Enum.map request_enum, &(&1)\n        GRPC.Server.send_reply(stream, reply1)\n        GRPC.Server.send_reply(stream, reply2)\n      end\n    end\n\nWith transcoding enabled gRPC methods can be used over HTTP/1 with JSON i.e\n\n    POST localhost/helloworld.Greeter/SayHello`\n    Content-Type: application/json\n    {\n      \"message\": \"gRPC\"\n    }\n\n    HTTP/1.1 200 OK\n    Content-Type: application/json\n    {\n      \"message\": \"Hello gRPC\"\n    }\n\nBy using  `option (google.api.http)` annotations in the `.proto` file the mapping between\nHTTP/JSON to gRPC methods and parameters can be customized:\n\n    syntax = \"proto3\";\n\n    import \"google/api/annotations.proto\";\n    import \"google/protobuf/timestamp.proto\";\n\n    package helloworld;\n\n    service Greeter {\n      rpc SayHello (HelloRequest) returns (HelloReply) {\n        option (google.api.http) = {\n          get: \"/v1/greeter/{name}\"\n        };\n      }\n    }\n\n    message HelloRequest {\n      string name = 1;\n    }\n\n    message HelloReply {\n      string message = 1;\n    }\n\nIn addition to the `POST localhost/helloworld.Greeter/SayHello` route in the previous examples\nthis creates an additional route: `GET localhost/v1/greeter/:name`\n\n    GET localhost/v1/greeter/gRPC\n    Accept: application/json\n\n    HTTP/1.1 200 OK\n    Content-Type: application/json\n    {\n      \"message\": \"Hello gRPC\"\n    }\n\nFor more comprehensive documentation on annotation usage in `.proto` files [see](https://cloud.google.com/endpoints/docs/grpc/transcoding)","ref":"GRPC.Server.html#module-grpc-http-json-transcoding"},{"type":"function","title":"GRPC.Server.send_headers/2","doc":"Send custom metadata(headers).\n\nYou can send headers only once, before that you can set headers using `set_headers/2`.","ref":"GRPC.Server.html#send_headers/2"},{"type":"function","title":"GRPC.Server.send_reply/3","doc":"Send streaming reply.","ref":"GRPC.Server.html#send_reply/3"},{"type":"function","title":"Examples - GRPC.Server.send_reply/3","doc":"iex> GRPC.Server.send_reply(stream, reply)","ref":"GRPC.Server.html#send_reply/3-examples"},{"type":"function","title":"GRPC.Server.set_compressor/2","doc":"Set compressor to compress responses. An accepted compressor will be set if clients use one,\neven if `set_compressor` is not called. But this can be called to override the chosen.","ref":"GRPC.Server.html#set_compressor/2"},{"type":"function","title":"GRPC.Server.set_headers/2","doc":"Set custom metadata(headers).\n\nYou can set headers more than once.","ref":"GRPC.Server.html#set_headers/2"},{"type":"function","title":"GRPC.Server.set_trailers/2","doc":"Set custom trailers, which will be sent in the end.","ref":"GRPC.Server.html#set_trailers/2"},{"type":"function","title":"GRPC.Server.stream_send/2","doc":"DEPRECATED. Use `send_reply/3` instead","ref":"GRPC.Server.html#stream_send/2"},{"type":"type","title":"GRPC.Server.rpc/0","doc":"","ref":"GRPC.Server.html#t:rpc/0"},{"type":"type","title":"GRPC.Server.rpc_req/0","doc":"","ref":"GRPC.Server.html#t:rpc_req/0"},{"type":"type","title":"GRPC.Server.rpc_return/0","doc":"","ref":"GRPC.Server.html#t:rpc_return/0"},{"type":"behaviour","title":"GRPC.Server.Adapter","doc":"HTTP server adapter for GRPC.","ref":"GRPC.Server.Adapter.html"},{"type":"callback","title":"GRPC.Server.Adapter.send_headers/2","doc":"","ref":"GRPC.Server.Adapter.html#c:send_headers/2"},{"type":"callback","title":"GRPC.Server.Adapter.send_reply/3","doc":"","ref":"GRPC.Server.Adapter.html#c:send_reply/3"},{"type":"callback","title":"GRPC.Server.Adapter.start/4","doc":"","ref":"GRPC.Server.Adapter.html#c:start/4"},{"type":"callback","title":"GRPC.Server.Adapter.stop/2","doc":"","ref":"GRPC.Server.Adapter.html#c:stop/2"},{"type":"type","title":"GRPC.Server.Adapter.state/0","doc":"","ref":"GRPC.Server.Adapter.html#t:state/0"},{"type":"module","title":"GRPC.Server.Adapters.Cowboy","doc":"A server (`b:GRPC.Server.Adapter`) adapter using `:cowboy`.\n\nCowboy requests will be stored in the `:payload` field of the `GRPC.Server.Stream`.","ref":"GRPC.Server.Adapters.Cowboy.html"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.child_spec/4","doc":"Return a child_spec to start server. See `GRPC.Server.Adapters.Cowboy.start/4` for a list of supported options.","ref":"GRPC.Server.Adapters.Cowboy.html#child_spec/4"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.get_bindings/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#get_bindings/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.get_cert/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#get_cert/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.get_headers/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#get_headers/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.get_peer/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#get_peer/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.get_qs/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#get_qs/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.read_body/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#read_body/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.reading_stream/1","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#reading_stream/1"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.send_trailers/2","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#send_trailers/2"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.set_compressor/2","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#set_compressor/2"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.set_headers/2","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#set_headers/2"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.set_resp_trailers/2","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#set_resp_trailers/2"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.start/4","doc":"Starts a Cowboy server. Only used in starting a server manually using `GRPC.Server.start(servers)`. Otherwise `GRPC.Server.Adapters.Cowboy.child_spec/4` is used.\n\nThe available options below are a subset of [`ranch_tcp`](https://ninenines.eu/docs/en/ranch/1.7/manual/ranch_tcp/)'s options.","ref":"GRPC.Server.Adapters.Cowboy.html#start/4"},{"type":"function","title":"Options - GRPC.Server.Adapters.Cowboy.start/4","doc":"* `:net` - If using `:inet` (IPv4 only - the default) or `:inet6` (IPv6)\n  * `:ip` - The IP to bind the server to.\n    Must be either a tuple in the format `{a, b, c, d}` with each value in `0..255` for IPv4,\n    or a tuple in the format `{a, b, c, d, e, f, g, h}` with each value in `0..65535` for IPv6,\n    or a tuple in the format `{:local, path}` for a unix socket at the given `path`.\n    If both `:net` and `:ip` options are given, make sure they are compatible\n    (i.e. give a IPv4 for `:inet` and IPv6 for `:inet6`). The default is to listen on all interfaces.\n  * `:ipv6_v6only` - If true, only bind on IPv6 addresses (default: `false`).","ref":"GRPC.Server.Adapters.Cowboy.html#start/4-options"},{"type":"function","title":"GRPC.Server.Adapters.Cowboy.start_link/4","doc":"","ref":"GRPC.Server.Adapters.Cowboy.html#start_link/4"},{"type":"behaviour","title":"GRPC.Server.Interceptor","doc":"Interceptor on server side. See `GRPC.Endpoint`.","ref":"GRPC.Server.Interceptor.html"},{"type":"callback","title":"GRPC.Server.Interceptor.call/4","doc":"","ref":"GRPC.Server.Interceptor.html#c:call/4"},{"type":"callback","title":"GRPC.Server.Interceptor.init/1","doc":"","ref":"GRPC.Server.Interceptor.html#c:init/1"},{"type":"type","title":"GRPC.Server.Interceptor.next/0","doc":"","ref":"GRPC.Server.Interceptor.html#t:next/0"},{"type":"type","title":"GRPC.Server.Interceptor.options/0","doc":"","ref":"GRPC.Server.Interceptor.html#t:options/0"},{"type":"type","title":"GRPC.Server.Interceptor.rpc_return/0","doc":"","ref":"GRPC.Server.Interceptor.html#t:rpc_return/0"},{"type":"module","title":"GRPC.Server.Interceptors.Logger","doc":"Print log around server rpc calls, like:\n\n    17:18:45.151 [info]  Handled by HelloServer.say_hello\n    17:18:45.151 [info]  Response :ok in 11µs","ref":"GRPC.Server.Interceptors.Logger.html"},{"type":"module","title":"Options - GRPC.Server.Interceptors.Logger","doc":"* `:level` - the desired log level. Defaults to `:info`","ref":"GRPC.Server.Interceptors.Logger.html#module-options"},{"type":"module","title":"Usage - GRPC.Server.Interceptors.Logger","doc":"defmodule Your.Endpoint do\n      use GRPC.Endpoint\n\n      intercept GRPC.Server.Interceptors.Logger, level: :info\n    end","ref":"GRPC.Server.Interceptors.Logger.html#module-usage"},{"type":"function","title":"GRPC.Server.Interceptors.Logger.formatted_diff/1","doc":"","ref":"GRPC.Server.Interceptors.Logger.html#formatted_diff/1"},{"type":"module","title":"GRPC.Server.Router","doc":"","ref":"GRPC.Server.Router.html"},{"type":"function","title":"GRPC.Server.Router.build_route/1","doc":"","ref":"GRPC.Server.Router.html#build_route/1"},{"type":"function","title":"GRPC.Server.Router.build_route/2","doc":"Builds a t:route/0 from a URL path or `t:Google.Api.Http.t/0`.\n\nThe matcher part in the route can be used in `match/3` to match on a URL path or a list of segments.","ref":"GRPC.Server.Router.html#build_route/2"},{"type":"function","title":"Examples - GRPC.Server.Router.build_route/2","doc":"{:get, \"/v1/messages/{message_id}\", match} = GRPC.Server.Router.build_route(:get, \"/v1/messages/{message_id}\")\n\n    {:get, path, match} = GRPC.Server.Router.build_route(:get, \"/v1/{book.location=shelves/*}/books/{book.name=*}\")\n    {true, %{\"book.location\": \"shelves/example-shelf\", \"book.name\": \"example-book\"}} = GRPC.Server.Router.match(\"/v1/shelves/example-shelf/books/example-book\", match, [])","ref":"GRPC.Server.Router.html#build_route/2-examples"},{"type":"function","title":"GRPC.Server.Router.match/2","doc":"Matches a URL path or URL segements against a compiled route matcher. Matched bindings from the segments are extracted\ninto a map. If the same variable name is used in multiple bindings, the value must match otherwise the route is not considered a match.","ref":"GRPC.Server.Router.html#match/2"},{"type":"function","title":"Examples - GRPC.Server.Router.match/2","doc":"{_, _, match} = GRPC.Server.Router.build_route(:get, \"/v1/{name=messages}\")\n    {true, %{name: \"messages\"}} = GRPC.Server.Router.match(\"/v1/messages\", match)\n    false = GRPC.Server.Router.match(\"/v1/messages/foobar\", match)\n\n\n    {_, _, match} = GRPC.Server.Router.build_route(:get, \"/v1/{name=shelves/*/books/*)\n    {true, %{name: \"shelves/books/book\"}} = GRPC.Server.Router.match(\"/v1/shelves/example-shelf/books/book\", match)\n\n    false = GRPC.Server.Router.match(\"/v1/shelves/example-shelf/something-els/books/book\", match)","ref":"GRPC.Server.Router.html#match/2-examples"},{"type":"function","title":"GRPC.Server.Router.match/3","doc":"","ref":"GRPC.Server.Router.html#match/3"},{"type":"function","title":"GRPC.Server.Router.split_path/1","doc":"Split URL path into segments, removing the leading and trailing slash.","ref":"GRPC.Server.Router.html#split_path/1"},{"type":"function","title":"Examples - GRPC.Server.Router.split_path/1","doc":"[\"v1\", \"messages\"] = GRPC.Server.Router.split_path(\"/v1/messages\")","ref":"GRPC.Server.Router.html#split_path/1-examples"},{"type":"type","title":"GRPC.Server.Router.http_method/0","doc":"","ref":"GRPC.Server.Router.html#t:http_method/0"},{"type":"type","title":"GRPC.Server.Router.route/0","doc":"","ref":"GRPC.Server.Router.html#t:route/0"},{"type":"module","title":"GRPC.Server.Stream","doc":"A struct as an argument that servers get in rpc function definitions and use to handle headers,\nsend streaming replies.\n\nNotice that you MUST use new stream returned by `GRPC.Server` as an argument to invoke next\nfunctions defined by `GRPC.Server`.","ref":"GRPC.Server.Stream.html"},{"type":"module","title":"Fields - GRPC.Server.Stream","doc":"* `:server`            - user defined gRPC server module\n  * `:adapter`           - a server adapter module, like `GRPC.Server.Adapters.Cowboy`\n  * `request_mod`        - the request module, or nil for untyped protocols\n  * `response_mod`       - the response module, or nil for untyped protocols\n  * `:codec`             - the codec\n  * `:payload`           - the payload needed by the adapter\n  * `:local`             - local data initialized by user","ref":"GRPC.Server.Stream.html#module-fields"},{"type":"function","title":"GRPC.Server.Stream.send_reply/3","doc":"","ref":"GRPC.Server.Stream.html#send_reply/3"},{"type":"type","title":"GRPC.Server.Stream.t/0","doc":"","ref":"GRPC.Server.Stream.html#t:t/0"},{"type":"module","title":"GRPC.Server.Supervisor","doc":"A simple supervisor to start your servers.\n\nYou can add it to your OTP tree as below.\nTo start the server, you can pass `start_server: true` and an option\n\n    defmodule Your.App do\n      use Application\n\n      def start(_type, _args) do\n        children = [\n          {GRPC.Server.Supervisor, endpoint: Your.Endpoint, port: 50051, start_server: true, ...}]\n\n        Supervisor.start_link(children, strategy: :one_for_one, name: __MODULE__)\n      end\n    end","ref":"GRPC.Server.Supervisor.html"},{"type":"function","title":"GRPC.Server.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GRPC.Server.Supervisor.html#child_spec/1"},{"type":"function","title":"GRPC.Server.Supervisor.child_spec/3","doc":"Return a child_spec to start server.","ref":"GRPC.Server.Supervisor.html#child_spec/3"},{"type":"function","title":"Options - GRPC.Server.Supervisor.child_spec/3","doc":"* `:cred` - a credential created by functions of `GRPC.Credential`,\n    an insecure server will be created without this option\n  * `:start_server` - determines if the server will be started.\n    If present, has more precedence then the `config :gprc, :start_server`\n    config value (i.e. `start_server: false` will not start the server in any case).","ref":"GRPC.Server.Supervisor.html#child_spec/3-options"},{"type":"function","title":"GRPC.Server.Supervisor.init/1","doc":"","ref":"GRPC.Server.Supervisor.html#init/1"},{"type":"function","title":"Options - GRPC.Server.Supervisor.init/1","doc":"* `:endpoint` - defines the endpoint module that will be started.\n  * `:port` - the HTTP port for the endpoint.\n  * `:servers` - the list of servers that will be be started.\n\nEither `:endpoint` or `:servers` must be present, but not both.","ref":"GRPC.Server.Supervisor.html#init/1-options"},{"type":"function","title":"GRPC.Server.Supervisor.start_link/1","doc":"","ref":"GRPC.Server.Supervisor.html#start_link/1"},{"type":"type","title":"GRPC.Server.Supervisor.sup_flags/0","doc":"","ref":"GRPC.Server.Supervisor.html#t:sup_flags/0"},{"type":"module","title":"GRPC.Service","doc":"Define gRPC service used by Stub and Server. You should use `Protobuf` to\nto generate code instead of using this module directly.\n\nIt imports DSL functions like `rpc/4` and `stream/1` for defining the RPC\nfunctions easily:\n\n    defmodule Greeter.Service do\n      use GRPC.Service, name: \"helloworld.Greeter\"\n\n      rpc :SayHello, HelloRequest, stream(HelloReply)\n    end\n\n`option (google.api.http)` annotations are supported for gRPC http/json transcoding. Once generated the 4th argument to `rpc/4` contains\nthe `Google.Api.HttpRule` option.\n\n    defmodule Greeter.Service do\n      use GRPC.Service, name: \"helloworld.Greeter\"\n\n      rpc(:SayHello, Helloworld.HelloRequest, Helloworld.HelloReply, %{\n        http: %{\n          type: Google.Api.PbExtension,\n          value: %Google.Api.HttpRule{\n            __unknown_fields__: [],\n            additional_bindings: [],\n            body: \"\",\n            pattern: {:get, \"/v1/greeter/{name}\"},\n            response_body: \"\",\n            selector: \"\"\n          }\n        }\n      })\n    end","ref":"GRPC.Service.html"},{"type":"function","title":"GRPC.Service.grpc_type/1","doc":"","ref":"GRPC.Service.html#grpc_type/1"},{"type":"macro","title":"GRPC.Service.rpc/4","doc":"","ref":"GRPC.Service.html#rpc/4"},{"type":"function","title":"GRPC.Service.rpc_options/1","doc":"","ref":"GRPC.Service.html#rpc_options/1"},{"type":"function","title":"GRPC.Service.rpc_options/2","doc":"","ref":"GRPC.Service.html#rpc_options/2"},{"type":"function","title":"GRPC.Service.stream/1","doc":"Specify if the request/reply is streaming.","ref":"GRPC.Service.html#stream/1"},{"type":"module","title":"GRPC.Status","doc":"A collection of gRPC statuses.\n\n|  Code  |         Status           |                                            Status Message                                           |\n|-------:|--------------------------|-----------------------------------------------------------------------------------------------------|\n|   `0`  |  `:ok`                   |  Success                                                                                            |\n|   `1`  |  `:cancelled`            |  The operation was cancelled (typically by the caller)                                              |\n|   `2`  |  `:unknown`              |  Unknown error                                                                                      |\n|   `3`  |  `:invalid_argument`     |  Client specified an invalid argument                                                               |\n|   `4`  |  `:deadline_exceeded`    |  Deadline expired before operation could complete                                                   |\n|   `5`  |  `:not_found`            |  Some requested entity (e.g., file or directory) was not found                                      |\n|   `6`  |  `:already_exists`       |  Some entity that we attempted to create (e.g., file or directory) already exists                   |\n|   `7`  |  `:permission_denied`    |  The caller does not have permission to execute the specified operation                             |\n|   `8`  |  `:resource_exhausted`   |  Some resource has been exhausted                                                                   |\n|   `9`  |  `:failed_precondition`  |  Operation was rejected because the system is not in a state required for the operation's execution |\n|  `10`  |  `:aborted`              |  The operation was aborted                                                                          |\n|  `11`  |  `:out_of_range`         |  Operation was attempted past the valid range                                                       |\n|  `12`  |  `:unimplemented`        |  Operation is not implemented or not supported/enabled in this service                              |\n|  `13`  |  `:internal`             |  Internal errors                                                                                    |\n|  `14`  |  `:unavailable`          |  The service is currently unavailable                                                               |\n|  `15`  |  `:data_loss`            |  Unrecoverable data loss or corruption                                                              |\n|  `16`  |  `:unauthenticated`      |  The request does not have valid authentication credentials for the operation                       |\n\nFor more details, please refer to the [official gRPC docs](https://github.com/grpc/grpc/blob/master/doc/statuscodes.md)","ref":"GRPC.Status.html"},{"type":"function","title":"GRPC.Status.aborted/0","doc":"The operation was aborted.\n\nTypically due to a concurrency issue like sequencer check failures,\ntransaction aborts, etc.","ref":"GRPC.Status.html#aborted/0"},{"type":"function","title":"GRPC.Status.already_exists/0","doc":"Some entity that we attempted to create (e.g., file or directory) already exists.","ref":"GRPC.Status.html#already_exists/0"},{"type":"function","title":"GRPC.Status.cancelled/0","doc":"The operation was cancelled (typically by the caller).","ref":"GRPC.Status.html#cancelled/0"},{"type":"function","title":"GRPC.Status.code_name/1","doc":"","ref":"GRPC.Status.html#code_name/1"},{"type":"function","title":"GRPC.Status.data_loss/0","doc":"Unrecoverable data loss or corruption.","ref":"GRPC.Status.html#data_loss/0"},{"type":"function","title":"GRPC.Status.deadline_exceeded/0","doc":"Deadline expired before operation could complete.\n\nFor operations that change the state of the system, this error may be returned\neven if the operation has completed successfully. For example, a\nsuccessful response from a server could have been delayed long\nenough for the deadline to expire.","ref":"GRPC.Status.html#deadline_exceeded/0"},{"type":"function","title":"GRPC.Status.failed_precondition/0","doc":"Operation was rejected because the system is not in a state\nrequired for the operation's execution.\n\nFor example, directory to be deleted may be non-empty,\nan rmdir operation is applied to a non-directory, etc.","ref":"GRPC.Status.html#failed_precondition/0"},{"type":"function","title":"GRPC.Status.http_code/1","doc":"","ref":"GRPC.Status.html#http_code/1"},{"type":"function","title":"GRPC.Status.internal/0","doc":"Internal errors.\n\nMeans some invariants expected by underlying system has been broken.\nIf you see one of these errors, something is very broken.","ref":"GRPC.Status.html#internal/0"},{"type":"function","title":"GRPC.Status.invalid_argument/0","doc":"Client specified an invalid argument.\n\nNote that this differs from FAILED_PRECONDITION.\nINVALID_ARGUMENT indicates arguments that are problematic regardless of\nthe state of the system (e.g., a malformed file name).","ref":"GRPC.Status.html#invalid_argument/0"},{"type":"function","title":"GRPC.Status.not_found/0","doc":"Some requested entity (e.g., file or directory) was not found.","ref":"GRPC.Status.html#not_found/0"},{"type":"function","title":"GRPC.Status.ok/0","doc":"Not an error; returned on success.","ref":"GRPC.Status.html#ok/0"},{"type":"function","title":"GRPC.Status.out_of_range/0","doc":"Operation was attempted past the valid range.\n\nE.g., seeking or reading past end of file.","ref":"GRPC.Status.html#out_of_range/0"},{"type":"function","title":"GRPC.Status.permission_denied/0","doc":"The caller does not have permission to execute the specified\noperation.\n\nPERMISSION_DENIED must not be used for rejections\ncaused by exhausting some resource (use RESOURCE_EXHAUSTED\ninstead for those errors).  PERMISSION_DENIED must not be\nused if the caller can not be identified (use UNAUTHENTICATED\ninstead for those errors).","ref":"GRPC.Status.html#permission_denied/0"},{"type":"function","title":"GRPC.Status.resource_exhausted/0","doc":"Some resource has been exhausted, perhaps a per-user quota, or\nperhaps the entire file system is out of space.","ref":"GRPC.Status.html#resource_exhausted/0"},{"type":"function","title":"GRPC.Status.status_message/1","doc":"","ref":"GRPC.Status.html#status_message/1"},{"type":"function","title":"GRPC.Status.unauthenticated/0","doc":"The request does not have valid authentication credentials for the operation.","ref":"GRPC.Status.html#unauthenticated/0"},{"type":"function","title":"GRPC.Status.unavailable/0","doc":"The service is currently unavailable.\n\nThis is a most likely a transient condition and may be corrected by retrying with\na backoff.","ref":"GRPC.Status.html#unavailable/0"},{"type":"function","title":"GRPC.Status.unimplemented/0","doc":"Operation is not implemented or not supported/enabled in this service.","ref":"GRPC.Status.html#unimplemented/0"},{"type":"function","title":"GRPC.Status.unknown/0","doc":"Unknown error.\n\nAn example of where this error may be returned is\nif a Status value received from another address space belongs to\nan error-space that is not known in this address space. Also\nerrors raised by APIs that do not return enough error information\nmay be converted to this error.","ref":"GRPC.Status.html#unknown/0"},{"type":"type","title":"GRPC.Status.t/0","doc":"","ref":"GRPC.Status.html#t:t/0"},{"type":"module","title":"GRPC.Stream","doc":"Some useful operations for streams.","ref":"GRPC.Stream.html"},{"type":"function","title":"GRPC.Stream.get_headers/1","doc":"Get headers from server stream.\n\nFor the client side, you should use `:return_headers` option to get headers,\nsee `GRPC.Stub` for details.","ref":"GRPC.Stream.html#get_headers/1"},{"type":"module","title":"GRPC.Stub","doc":"A module acting as the interface for gRPC client.\n\nYou can do everything in the client side via `GRPC.Stub`, including connecting,\nsending/receiving streaming or non-streaming requests, canceling calls and so on.\n\nA service is needed to define a stub:\n\n    defmodule Greeter.Service do\n      use GRPC.Service, name: \"ping\"\n\n      rpc :SayHello, Request, Reply\n      rpc :SayGoodbye, stream(Request), stream(Reply)\n    end\n\n    defmodule Greeter.Stub do\n      use GRPC.Stub, service: Greeter.Service\n    end\n\nso that functions `say_hello/2` and `say_goodbye/1` will be generated for you:\n\n    # Unary call\n    {:ok, reply} = Greeter.Stub.say_hello(channel, request)\n\n    # Streaming call\n    stream = Greeter.Stub.say_goodbye(channel)\n    GRPC.Stub.send_request(stream, request, end_stream: true)\n    {:ok, reply_enum} = GRPC.Stub.recv(stream)\n    replies = Enum.map(reply_enum, fn({:ok, reply}) -> reply end)\n\nNote that streaming calls are very different with unary calls. If request is\nstreaming, the RPC function only accepts channel as argument and returns a\n`GRPC.Client.Stream`. You can send streaming requests one by one via `send_request/3`,\nthen use `recv/1` to receive the reply. And if the reply is streaming, `recv/1`\nreturns a `Stream`.\n\nYou can refer to `call/6` for doc of your RPC functions.","ref":"GRPC.Stub.html"},{"type":"function","title":"GRPC.Stub.cancel/1","doc":"Cancel a stream in a streaming client.\n\nAfter that, callings to `recv/2` will return a CANCEL error.","ref":"GRPC.Stub.html#cancel/1"},{"type":"function","title":"GRPC.Stub.connect/2","doc":"Establish a connection with gRPC server and return `GRPC.Channel` needed for\nsending requests.","ref":"GRPC.Stub.html#connect/2"},{"type":"function","title":"Examples - GRPC.Stub.connect/2","doc":"iex> GRPC.Stub.connect(\"localhost:50051\")\n    {:ok, channel}\n\n    iex> GRPC.Stub.connect(\"localhost:50051\", accepted_compressors: [GRPC.Compressor.Gzip])\n    {:ok, channel}\n\n    iex> GRPC.Stub.connect(\"/paht/to/unix.sock\")\n    {:ok, channel}","ref":"GRPC.Stub.html#connect/2-examples"},{"type":"function","title":"Options - GRPC.Stub.connect/2","doc":"* `:cred` - a `GRPC.Credential` used to indicate it's a secure connection.\n    An insecure connection will be created without this option.\n  * `:adapter` - custom client adapter\n  * `:interceptors` - client interceptors\n  * `:codec` - client will use this to encode and decode binary message\n  * `:compressor` - the client will use this to compress requests and decompress responses. If this is set, accepted_compressors\n      will be appended also, so this can be used safely without `:accepted_compressors`.\n  * `:accepted_compressors` - tell servers accepted compressors, this can be used without `:compressor`\n  * `:headers` - headers to attach to each request","ref":"GRPC.Stub.html#connect/2-options"},{"type":"function","title":"GRPC.Stub.connect/3","doc":"","ref":"GRPC.Stub.html#connect/3"},{"type":"function","title":"GRPC.Stub.disconnect/1","doc":"Disconnects the adapter and frees any resources the adapter is consuming","ref":"GRPC.Stub.html#disconnect/1"},{"type":"function","title":"GRPC.Stub.end_stream/1","doc":"Send END_STREAM frame to end the stream.\n\nThe stream will be in half_closed state after this is called.","ref":"GRPC.Stub.html#end_stream/1"},{"type":"function","title":"Examples - GRPC.Stub.end_stream/1","doc":"iex> stream = GRPC.Stub.send_request(stream, request)\n    iex> GRPC.Stub.end_stream(stream)","ref":"GRPC.Stub.html#end_stream/1-examples"},{"type":"function","title":"GRPC.Stub.recv/2","doc":"Receive replies when requests are streaming.\n\n* If the reply is not streaming, a normal reply struct will be returned\n* If the reply is streaming, a enumerable `Stream` will be returned.\n  You can use `Enum` to fetch further replies or `Stream` to manipulate it.\n  Each item in the `Enumerable` is a tuple `{:ok, reply}` or `{:error, error}`.\n  When `:return_headers` is true, the last item in the `Enumerable` will be\n  `{:trailers, map}`","ref":"GRPC.Stub.html#recv/2"},{"type":"function","title":"Examples - GRPC.Stub.recv/2","doc":"# Reply is not streaming\n    {:ok, reply} = GRPC.Stub.recv(stream)\n\n    # Reply is streaming\n    {:ok, ex_stream} = GRPC.Stub.recv(stream)\n    replies = Enum.map(ex_stream, fn({:ok, reply}) -> reply end)","ref":"GRPC.Stub.html#recv/2-examples"},{"type":"function","title":"Options - GRPC.Stub.recv/2","doc":"* `:timeout` - request timeout\n  * `:deadline` - when the request is timeout, will override timeout\n  * `:return_headers` - when true, headers will be returned.","ref":"GRPC.Stub.html#recv/2-options"},{"type":"function","title":"Stream behavior - GRPC.Stub.recv/2","doc":"We build the Stream struct using `Stream.unfold/2`.\n\nThe unfold function is built in such a way that  - for both adapters - the accumulator is a map used to find the\n`connection_stream`process and the `next_fun` argument is a function that reads directly from the `connection_stream`\nthat is producing data.\nEvery time we execute `next_fun` we read a chunk of data. This means that `next_fun` will have the side effect of updating the state of the `connection_stream` process, removing the chunk of data that's being read from the underlying `GenServer`'s state.","ref":"GRPC.Stub.html#recv/2-stream-behavior"},{"type":"function","title":"Examples - GRPC.Stub.recv/2","doc":"iex> ex_stream |> Stream.take(1) |> Enum.to_list()\n    [1]\n    iex> ex_stream |> Enum.to_list()\n    [2, 3]\n    iex> ex_stream |> Enum.to_list()\n    []","ref":"GRPC.Stub.html#recv/2-examples"},{"type":"function","title":"GRPC.Stub.retry_timeout/1","doc":"","ref":"GRPC.Stub.html#retry_timeout/1"},{"type":"function","title":"GRPC.Stub.send_request/3","doc":"Send streaming requests.\n\nThe last request can be sent with `:end_stream` option, or you can call `end_stream/1`\nto send a frame with END_STREAM flag to end the stream.","ref":"GRPC.Stub.html#send_request/3"},{"type":"function","title":"Options - GRPC.Stub.send_request/3","doc":"* `:end_stream` - indicates it's the last one request, then the stream will be in\n    half_closed state. Default is false.","ref":"GRPC.Stub.html#send_request/3-options"},{"type":"function","title":"GRPC.Stub.stream_send/3","doc":"DEPRECATED. Use `send_request/3` instead","ref":"GRPC.Stub.html#stream_send/3"},{"type":"type","title":"GRPC.Stub.receive_data_return/0","doc":"","ref":"GRPC.Stub.html#t:receive_data_return/0"},{"type":"type","title":"GRPC.Stub.rpc_return/0","doc":"","ref":"GRPC.Stub.html#t:rpc_return/0"},{"type":"module","title":"GRPC.Telemetry","doc":"Events published by GRPC\n\nThese can be divided in client-side events and server-side events.","ref":"GRPC.Telemetry.html"},{"type":"module","title":"Client-side Events - GRPC.Telemetry","doc":"* `[:grpc, :client, :rpc, :start]` - Published before all interceptors are executed.\n  * `[:grpc, :client, :rpc, :stop]` - Published after all interceptors executed successfully.\n    * `:duration` - the duration as measured through `System.monotonic_time()`\n      for the whole interceptor pipeline.\n  * `[:grpc, :client, :rpc, :exception]` - Published if any exception occurs while receiving a message.\n    * `:duration` - the duration as measured through `System.monotonic_time()`\n      for the execution since the start of the pipeline until the exception happened.\n\n| event        | measurements | metadata |\n|--------------|--------------|----------|\n| `[:rpc, :start]`  | `:count`     | `:stream` |\n| `[:rpc, :stop]`  | `:duration`  | `:stream` |\n| `[:rpc, :exception]` | `:duration`  | `:stream`, `:kind`, `:reason`, `:stacktrace` |\n\n#","ref":"GRPC.Telemetry.html#module-client-side-events"},{"type":"module","title":"Metadata - GRPC.Telemetry","doc":"* `:stream` - the `%GRPC.Server.Stream{}` for the request\n  * `:function_name` - the name of the function called\n  * `:server` - the server module name\n  * `:endpoint` - the endpoint module name\n  * `:request` - the client request\n  * `:result` - the result returned from the interceptor pipeline.\n\n`:exception` events also include some error metadata:\n\n  * `:reason` is the error value in case of `catch` or the actual exception in case of `rescue`.\n  * `:kind` can be one of:\n    * `:error` — from an `{:error, error}` return value. Some Erlang functions may also throw an\n      `:error` tuple, which will be reported as `:error`.\n    * `:exit` — from a caught process exit.\n    * `:throw` — from a caught value, this doesn't necessarily mean that an error occurred.","ref":"GRPC.Telemetry.html#module-metadata"},{"type":"module","title":"Server-side Events - GRPC.Telemetry","doc":"* `[:grpc, :server, :rpc, :start]` - Published before all interceptors are executed.\n  * `[:grpc, :server, :rpc, :stop]` - Published after all interceptors executed successfully.\n    * `:duration` - the duration as measured through `System.monotonic_time()`\n      for the whole interceptor pipeline.\n  * `[:grpc, :server, :rpc, :exception]` - Published if any exception occurs while receiving a message.\n    * `:duration` - the duration as measured through `System.monotonic_time()`\n      for the execution since the start of the pipeline until the exception happened.\n\n| event        | measurements | metadata |\n|--------------|--------------|----------|\n| `[:rpc, :start]`  | `:count`     | `:stream`, `:server`, `:endpoint`, `:function_name` |\n| `[:rpc, :stop]`  | `:duration`  | `:stream`, `:server`, `:endpoint`, `:function_name` , `:result` |\n| `[:rpc, :exception]` | `:duration`  | `:stream`, `:server`, `:endpoint`, `:function_name`, `:kind`, `:reason`, `:stacktrace` |\n\n#","ref":"GRPC.Telemetry.html#module-server-side-events"},{"type":"module","title":"Metadata - GRPC.Telemetry","doc":"* `:stream` - the `%GRPC.Server.Stream{}` for the request.\n  * `:function_name` - the name of the function called.\n  * `:server` - the server module name.\n  * `:endpoint` - the endpoint module name.\n  * `:result` - the result returned from the interceptor pipeline.\n\n`:exception` events also include some error metadata:\n\n  * `:reason` is the error value in case of `catch` or the actual exception in case of `rescue`.\n  * `:kind` can be one of:\n    * `:error` — from an `{:error, error}` return value. Some Erlang functions may also throw an\n      `:error` tuple, which will be reported as `:error`.\n    * `:exit` — from a caught process exit.\n    * `:throw` — from a caught value, this doesn't necessarily mean that an error occurred.","ref":"GRPC.Telemetry.html#module-metadata"},{"type":"function","title":"GRPC.Telemetry.client_rpc_prefix/0","doc":"The client telemetry event prefix.","ref":"GRPC.Telemetry.html#client_rpc_prefix/0"},{"type":"function","title":"GRPC.Telemetry.server_rpc_prefix/0","doc":"The server telemetry event prefix.","ref":"GRPC.Telemetry.html#server_rpc_prefix/0"},{"type":"behaviour","title":"GRPC.ClientInterceptor","doc":"Interceptor on client side. See `GRPC.Stub.connect/2`.","ref":"GRPC.ClientInterceptor.html"},{"type":"callback","title":"GRPC.ClientInterceptor.call/4","doc":"","ref":"GRPC.ClientInterceptor.html#c:call/4"},{"type":"callback","title":"GRPC.ClientInterceptor.init/1","doc":"","ref":"GRPC.ClientInterceptor.html#c:init/1"},{"type":"type","title":"GRPC.ClientInterceptor.next/0","doc":"","ref":"GRPC.ClientInterceptor.html#t:next/0"},{"type":"type","title":"GRPC.ClientInterceptor.options/0","doc":"","ref":"GRPC.ClientInterceptor.html#t:options/0"},{"type":"type","title":"GRPC.ClientInterceptor.req/0","doc":"","ref":"GRPC.ClientInterceptor.html#t:req/0"},{"type":"behaviour","title":"GRPC.ServerInterceptor","doc":"Interceptor on server side. See `GRPC.Endpoint`.","ref":"GRPC.ServerInterceptor.html"},{"type":"callback","title":"GRPC.ServerInterceptor.call/4","doc":"","ref":"GRPC.ServerInterceptor.html#c:call/4"},{"type":"callback","title":"GRPC.ServerInterceptor.init/1","doc":"","ref":"GRPC.ServerInterceptor.html#c:init/1"},{"type":"type","title":"GRPC.ServerInterceptor.next/0","doc":"","ref":"GRPC.ServerInterceptor.html#t:next/0"},{"type":"type","title":"GRPC.ServerInterceptor.options/0","doc":"","ref":"GRPC.ServerInterceptor.html#t:options/0"},{"type":"type","title":"GRPC.ServerInterceptor.rpc_return/0","doc":"","ref":"GRPC.ServerInterceptor.html#t:rpc_return/0"},{"type":"exception","title":"GRPC.RPCError","doc":"The RPC error raised in server side and got in client side.\n\n    # server side\n    raise GRPC.RPCError, status: :unknown # preferred\n    raise GRPC.RPCError, status: GRPC.Status.unknown, message: \"error message\"\n\n    # client side\n    {:error, error} = Your.Stub.unary_call(channel, request)\n\nError handling can be done with the `is_rpc_error/2` guard.\n\nExpanding on the code above, the first option is for the guard to\nbe used in a `cond` or `case`, as follows:\n\n    cond do\n      is_rpc_error(error, GRPC.Status.not_found()) ->\n        do_something_when_not_found()\n\n      is_rpc_error(error, GRPC.Status.out_of_range()) ->\n        do_something_when_out_of_range()\n\n      true ->\n        fallback_code()\n    end\n\nAnother option is for the error handling to be written into a multi-clause function.\nIn such case we must define module attributes for each of the errors we want because\nthe functions in `GRPC.Status` can't be called directly inside the guard.\n\n    ...\n    handle_error(error)\n    ...\n\n    @not_found GRPC.Status.not_found()\n    @out_of_range GRPC.Status.out_of_range()\n\n    defp handle_error(error) when is_rpc_error(error, @not_found) do\n      # not found\n    end\n\n    defp handle_error(error) when is_rpc_error(error, @out_of_range) do\n      # out of range\n    end\n\n    defp handle_error(error) do\n      # fallback\n    end\n\nSee `GRPC.Status` for more details on possible statuses.","ref":"GRPC.RPCError.html"},{"type":"function","title":"GRPC.RPCError.exception/2","doc":"","ref":"GRPC.RPCError.html#exception/2"},{"type":"macro","title":"GRPC.RPCError.is_rpc_error/2","doc":"","ref":"GRPC.RPCError.html#is_rpc_error/2"},{"type":"function","title":"GRPC.RPCError.new/1","doc":"","ref":"GRPC.RPCError.html#new/1"},{"type":"type","title":"GRPC.RPCError.t/0","doc":"","ref":"GRPC.RPCError.html#t:t/0"},{"type":"extras","title":"gRPC Elixir","doc":"# gRPC Elixir\n\n[![Hex.pm](https://img.shields.io/hexpm/v/grpc.svg)](https://hex.pm/packages/grpc)\n[![Travis Status](https://app.travis-ci.com/elixir-grpc/grpc.svg?branch=master)](https://app.travis-ci.com/elixir-grpc/grpc)\n[![GitHub actions Status](https://github.com/elixir-grpc/grpc/workflows/CI/badge.svg)](https://github.com/elixir-grpc/grpc/actions)\n[![License](https://img.shields.io/hexpm/l/grpc.svg)](https://github.com/elixir-grpc/grpc/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/elixir-grpc/grpc.svg)](https://github.com/elixir-grpc/grpc/commits/master)\n[![Total Download](https://img.shields.io/hexpm/dt/grpc.svg)](https://hex.pm/packages/elixir-grpc/grpc)\n\nAn Elixir implementation of [gRPC](http://www.grpc.io/).","ref":"readme.html"},{"type":"extras","title":"Table of contents - gRPC Elixir","doc":"- [Installation](#installation)\n- [Usage](#usage)\n  - [Simple RPC](#simple-rpc)\n  - [HTTP Transcoding](#http-transcoding)\n  - [Start Application](#start-application)\n- [Features](#features)\n- [Benchmark](#benchmark)\n- [Contributing](#contributing)","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Installation - gRPC Elixir","doc":"The package can be installed as:\n\n  ```elixir\n  def deps do\n    [\n      {:grpc, \"~> 0.7\"},\n      # We don't force protobuf as a dependency for more\n      # flexibility on which protobuf library is used,\n      # but you probably want to use it as well\n      {:protobuf, \"~> 0.11\"}\n    ]\n  end\n  ```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - gRPC Elixir","doc":"1. Write your protobuf file:\n\n```protobuf\nsyntax = \"proto3\";\n\npackage helloworld;\n\n// The request message containing the user's name.\nmessage HelloRequest {\n  string name = 1;\n}\n\n// The response message containing the greeting\nmessage HelloReply {\n  string message = 1;\n}\n\n// The greeting service definition.\nservice Greeter {\n  // Greeting function\n  rpc SayHello (HelloRequest) returns (HelloReply) {}\n}\n\n```\n\n2. Then generate Elixir code from proto file as [protobuf-elixir](https://github.com/tony612/protobuf-elixir#usage) shows (especially the `gRPC Support` section) or using [protobuf_generate](https://hex.pm/packages/protobuf_generate) hex package. Example using `protobuf_generate` lib:\n\n```shell\nmix protobuf.generate --output-path=./lib --include-path=./priv/protos helloworld.proto\n```\n\nIn the following sections you will see how to implement gRPC server logic.\n\n### **Simple RPC**\n\n1. Implement the server side code like below and remember to return the expected message types.\n\n```elixir\ndefmodule Helloworld.Greeter.Server do\n  use GRPC.Server, service: Helloworld.Greeter.Service\n\n  @spec say_hello(Helloworld.HelloRequest.t, GRPC.Server.Stream.t) :: Helloworld.HelloReply.t\n  def say_hello(request, _stream) do\n    Helloworld.HelloReply.new(message: \"Hello #{request.name}\")\n  end\nend\n```\n\n2. Define gRPC endpoints\n\n```elixir\n# Define your endpoint\ndefmodule Helloworld.Endpoint do\n  use GRPC.Endpoint\n\n  intercept GRPC.Server.Interceptors.Logger\n  run Helloworld.Greeter.Server\nend\n```\n\nWe will use this module [in the gRPC server startup section](#start-application).\n\n**__Note:__** For other types of RPC call like streams see [here](interop/lib/interop/server.ex).\n\n### **HTTP Transcoding**\n\n1. Adding [grpc-gateway annotations](https://cloud.google.com/endpoints/docs/grpc/transcoding) to your protobuf file definition: \n\n```protobuf\nimport \"google/api/annotations.proto\";\nimport \"google/protobuf/timestamp.proto\";\n\npackage helloworld;\n\n// The greeting service definition.\nservice Greeter {\n  // Sends a greeting\n  rpc SayHello (HelloRequest) returns (HelloReply) {\n    option (google.api.http) = {\n      get: \"/v1/greeter/{name}\"\n    };\n  }\n\n  rpc SayHelloFrom (HelloRequestFrom) returns (HelloReply) {\n    option (google.api.http) = {\n      post: \"/v1/greeter\"\n      body: \"*\"\n    };\n  }\n}\n```\n\n2. Add protoc plugin dependency and compile your protos using [protobuf_generate](https://github.com/drowzy/protobuf_generate) hex [package](https://hex.pm/packages/protobuf_generate):\n\nIn mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:grpc, \"~> 0.7\"},\n    {:protobuf_generate, \"~> 0.1.1\"}\n  ]\nend\n```\n\nAnd in your terminal:\n\n```shell\nmix protobuf.generate \\\n  --include-path=priv/proto \\\n  --include-path=deps/googleapis \\\n  --generate-descriptors=true \\\n  --output-path=./lib \\\n  --plugins=ProtobufGenerate.Plugins.GRPCWithOptions \\\n  google/api/annotations.proto google/api/http.proto helloworld.proto\n```\n\n3. Enable http_transcode option in your Server module\n```elixir\ndefmodule Helloworld.Greeter.Server do\n  use GRPC.Server, \n    service: Helloworld.Greeter.Service,\n    http_transcode: true\n\n  @spec say_hello(Helloworld.HelloRequest.t, GRPC.Server.Stream.t) :: Helloworld.HelloReply.t\n  def say_hello(request, _stream) do\n    %Helloworld.HelloReply{message: \"Hello #{request.name}\"}\n  end\nend\n```\n\nSee full application code in [helloworld_transcoding](examples/helloworld_transcoding) example.\n\n### **Start Application**\n\n1. Start gRPC Server in your supervisor tree or Application module:\n\n```elixir\n# In the start function of your Application\ndefmodule HelloworldApp do\n  use Application\n  def start(_type, _args) do\n    children = [\n      # ...\n      {GRPC.Server.Supervisor, endpoint: Helloworld.Endpoint, port: 50051, start_server: true}\n    ]\n\n    opts = [strategy: :one_for_one, name: YourApp]\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\n2. Call rpc:\n\n```elixir\niex> {:ok, channel} = GRPC.Stub.connect(\"localhost:50051\")\niex> request = Helloworld.HelloRequest.new(name: \"grpc-elixir\")\niex> {:ok, reply} = channel |> Helloworld.Greeter.Stub.say_hello(request)\n\n# With interceptors\niex> {:ok, channel} = GRPC.Stub.connect(\"localhost:50051\", interceptors: [GRPC.Client.Interceptors.Logger])\n...\n```\n\nCheck the [examples](examples) and [interop](interop) directories in the project's source code for some examples.","ref":"readme.html#usage"},{"type":"extras","title":"Features - gRPC Elixir","doc":"- Various kinds of RPC:\n  - [Unary](https://grpc.io/docs/what-is-grpc/core-concepts/#unary-rpc)\n  - [Server-streaming](https://grpc.io/docs/what-is-grpc/core-concepts/#server-streaming-rpc)\n  - [Client-streaming](https://grpc.io/docs/what-is-grpc/core-concepts/#client-streaming-rpc)\n  - [Bidirectional-streaming](https://grpc.io/docs/what-is-grpc/core-concepts/#bidirectional-streaming-rpc)\n- [HTTP Transcoding](https://cloud.google.com/endpoints/docs/grpc/transcoding)\n- [TLS Authentication](https://grpc.io/docs/guides/auth/#supported-auth-mechanisms)\n- [Error handling](https://grpc.io/docs/guides/error/)\n- Interceptors (See [`GRPC.Endpoint`](https://github.com/elixir-grpc/grpc/blob/master/lib/grpc/endpoint.ex))\n- [Connection Backoff](https://github.com/grpc/grpc/blob/master/doc/connection-backoff.md)\n- Data compression\n- [gRPC Reflection](https://github.com/elixir-grpc/grpc-reflection)","ref":"readme.html#features"},{"type":"extras","title":"Benchmark - gRPC Elixir","doc":"1. [Simple benchmark](examples/helloworld/README.md#Benchmark) by using [ghz](https://ghz.sh/)\n\n2. [Benchmark](benchmark) followed by official spec","ref":"readme.html#benchmark"},{"type":"extras","title":"Contributing - gRPC Elixir","doc":"Your contributions are welcome!\n\nPlease open issues if you have questions, problems and ideas. You can create pull\nrequests directly if you want to fix little bugs, add small features and so on.\nBut you'd better use issues first if you want to add a big feature or change a\nlot of code.","ref":"readme.html#contributing"}],"content_type":"text/markdown"}